#!/bin/bash
BASEDIR=$(dirname $0)
echo searching for Info.plist to update...
for file in $(find /usr/lib* -name "Info.plist" | grep "ifd-ccid.bundle/Contents" ); do
	NOW=$(date +%d-%m-%y-%T)
	cp -f ${file} ${file}.$NOW.orig	
	echo updating $file
    $BASEDIR/check_plist_integrity.sh ${file}
	if [ "$?" -eq 1 ]; then
		exit 1
	fi
	
	echo updating $file
	cp -f ${file} ${file}.orig	
	$BASEDIR/remove_by_friendly_name.sh '<string>.*ARDS.*</string>'  ${file} 
	$BASEDIR/remove_by_friendly_name.sh '<string>.*Aladdin R.D.*</string>'  ${file}
	$BASEDIR/remove_by_friendly_name.sh '<string>.*JaCarta.*</string>'  ${file}
	$BASEDIR/remove_by_friendly_name.sh '<string>.*JCR-770.*</string>'  ${file}
	$BASEDIR/remove_by_friendly_name.sh '<string>.*bR301.*</string>'  ${file}
	$BASEDIR/remove_by_friendly_name.sh '<string>.*iR301.*</string>'  ${file}

	$BASEDIR/update_ifd_ccid_bundle.sh ${file} "0x24DC" "0x0101" "Aladdin R.D. JaCarta" > ${file}.tmp
	$BASEDIR/update_ifd_ccid_bundle.sh ${file}.tmp "0x24DC" "0x0201" "Aladdin R.D. JCR-770" > ${file}.tmp1
	$BASEDIR/update_ifd_ccid_bundle.sh ${file}.tmp1 "0x24DC" "0x100F" "Aladdin R.D. JaCarta Flash" > ${file}.tmp2
	$BASEDIR/update_ifd_ccid_bundle.sh ${file}.tmp2 "0x096e" "0x061A" "bR301" > ${file}.tmp3
	$BASEDIR/update_ifd_ccid_bundle.sh ${file}.tmp3 "0x096e" "0x061C" "iR301" > ${file}.tmp4
	$BASEDIR/update_ifd_ccid_bundle.sh ${file}.tmp4 "0x096e" "0x0619" "iR301" > ${file}.tmp5
	$BASEDIR/update_ifd_ccid_bundle.sh ${file}.tmp5 "0x24DC" "0x0102" "Aladdin R.D. JaCarta LT" > ${file}.tmp
	
	echo checking updated $file
	 $BASEDIR/check_plist_integrity.sh ${file}.tmp
	if [ "$?" -eq 1 ]; then
		exit 1
	fi
	
	chown --reference=${file} ${file}.tmp
	chmod --reference=${file} ${file}.tmp
	mv -f ${file}.tmp ${file}
	rm -f ${file}.tmp*
done
